var QMglobals = {
    initIter    : 0,
    prefSvc     : Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch),
    obSvc       : Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService),

    updateObserver: {
        // this ensures that all windows ( including standalone ) will get updated properly
        observe: function(subject, topic, state) {
            if (topic == "update_QMsettings") {
                QMglobals.deleteItems();
                QMglobals.createItems();
            }
        }
    },

    logStringMessage: function(msgg) {
        try{
            if (QMglobals.prefSvc.getBoolPref("quickmove.debug")) {
                Components.classes["@mozilla.org/consoleservice;1"].
                    getService(Components.interfaces.nsIConsoleService).
                    logStringMessage(msgg);
            }
        } catch(e) {
            QMglobals.prefSvc.setBoolPref("quickmove.debug",false)
        }
    },
    
    init: function() {
        // remove the built-in keys for ctrl+1 and ctrl+2
        QMglobals.obSvc.addObserver(QMglobals.updateObserver, "update_QMsettings", false);
        var keyset = document.getElementById("mailKeys");
        try{ 
            var dkey = document.getElementById("key_addressbook");
            dkey.parentNode.removeChild(dkey);
            var dkey = document.getElementById("key_mail");
            dkey.parentNode.removeChild(dkey);
        } catch(e) {}
        QMglobals.logStringMessage('QM moveitems, removed built-in shortcut keys ctrl1 and ctrl2');
        // now set ALL of the ctrl keys for this extension
        for (var a = 0; a < 10; a++) {
            var newKeyItem = document.createElement("key");
            var keyid = "qm" + a
            newKeyItem.setAttribute("id", keyid);
            newKeyItem.setAttribute("key", a);
            newKeyItem.setAttribute("charcode", a);
            newKeyItem.setAttribute("modifiers", "accel");
            keyset.appendChild(newKeyItem);
        }
        QMglobals.logStringMessage('QM moveitems, added keyitems for QM');
        var grandParent = document.getElementById("messageMenu");
        var parent = grandParent.childNodes[0];
        var newMenuItem = document.createElement("menuseparator");
        var tPaneContext = document.getElementById("threadPaneContext")
        var tPaneItem = newMenuItem.cloneNode(true);
        tPaneContext.appendChild(tPaneItem);
        var newObservesItem = document.createElement("observes");
        newObservesItem.setAttribute("element", "cmd_editAsNew");
        newObservesItem.setAttribute("attribute", "disabled");
        newMenuItem.appendChild(newObservesItem);
        parent.appendChild(newMenuItem);
        var newMenuItem = document.createElement("menuitem");
        newMenuItem.setAttribute("label", "Set QM Options");
        newMenuItem.setAttribute("id", "qmMenuSet");
        newMenuItem.setAttribute("userdefined", "true");
        var oncommandStr = "window.openDialog('chrome://quikmov/content/settings.xul', '', 'chrome');";  
        newMenuItem.setAttribute("oncommand", oncommandStr);
        parent.appendChild(newMenuItem);
        QMglobals.createItems();
    },

    createItems: function() {
        var grandParent = document.getElementById("messageMenu");
        var parent = grandParent.childNodes[0];
        QMglobals.logStringMessage('QM create items, start');
        for (var a = 0; a < 10; a++) {
            var keyid = "qm" + a
            var keyItem = document.getElementById(keyid);
            var oncommandStr = "";  
            keyItem.setAttribute("oncommand", oncommandStr);
            try {
                var qfuri = QMglobals.prefSvc.getCharPref("quickmove.qf" + a);
                if (qfuri == '') {
                    continue; 
                }
            } catch(e) {
                continue;
            }
            // make the menuitem
            var msgfolder = GetMsgFolderFromUri(qfuri, false);
            var prettyfname = "QM to " + document.getElementById("bundle_messenger").getFormattedString("verboseFolderFormat", [msgfolder.name, msgfolder.server.prettyName]);
            var newMenuItem = document.createElement("menuitem");
            newMenuItem.setAttribute("label", prettyfname);
            var menuid = "qmMenu" + a
            newMenuItem.setAttribute("id", menuid);
            newMenuItem.setAttribute("userdefined", "true");
            var oncommandStr = "QMglobals.doCommand('" + qfuri + "',event);";  
            newMenuItem.setAttribute("oncommand", oncommandStr);
            var tPaneContext = document.getElementById("threadPaneContext")
            var tPaneItem = newMenuItem.cloneNode(true);
            var tmenuid = "qmtMenu" + a
            tPaneItem.setAttribute("id", tmenuid);
            tPaneContext.appendChild(tPaneItem);
            var newObservesItem = document.createElement("observes");
            oncommandStr = "QMglobals.doCommand('" + qfuri + "',event,true);";  
            keyItem.setAttribute("oncommand", oncommandStr);
            newMenuItem.setAttribute("key", keyid);
            newObservesItem.setAttribute("element", "cmd_editAsNew");
            newObservesItem.setAttribute("attribute", "disabled");
            newMenuItem.appendChild(newObservesItem);
            parent.appendChild(newMenuItem);
            QMglobals.logStringMessage('QM create items, added menu item >' + prettyfname);
        }    
    },    

    deleteItems: function() {
        QMglobals.logStringMessage('QM delete items, start');
        var keyset = document.getElementById("mailKeys");
        for (var a = 0; a < 10; a++) {
            var menuid = "qmMenu" + a
            try {
                var menuItem = document.getElementById(menuid);
                menuItem.parentNode.removeChild(menuItem);
                QMglobals.logStringMessage('QM delete items, deleted qmMenu item >' + a);
            } catch(e) {}
            var tmenuid = "qmtMenu" + a
            try {
                var menuItem = document.getElementById(tmenuid);
                menuItem.parentNode.removeChild(menuItem);
                QMglobals.logStringMessage('QM delete items, deleted qmtMenu item >' + a);
            } catch(e) {}
        }   
    },
    
    doCommand: function(uri,event,fromKey) {
        try {
            QMglobals.logStringMessage('QM do command, start, uri >' + uri);
            var dbv = GetDBView();
            toFolder = RDF.GetResource(uri).QueryInterface(Components.interfaces.nsIMsgFolder);
            if (event) {
                if (event.ctrlKey && !fromKey) {
                    QMglobals.logStringMessage('QM do command, attempting to copy the message');
                    dbv.doCommandWithFolder(nsMsgViewCommandType.copyMessages, toFolder);
                } else {
                    QMglobals.logStringMessage('QM do command, attempting to move the message');
                    dbv.doCommandWithFolder(nsMsgViewCommandType.moveMessages, toFolder);
                }
            } else {
                QMglobals.logStringMessage('QM do command, attempting to move the message (no event)');
                dbv.doCommandWithFolder(nsMsgViewCommandType.moveMessages, toFolder);
            }
        } catch(e) { 
            QMglobals.logStringMessage('QM do command, error >' + e);
        }
    }
}
addEventListener("load", QMglobals.init, false);
